`timescale 1ps / 1ps
module gazou_gen_a (
  clk,
  rstb,
  tmg_da_en,
  v_c,
  h_c,
  gen_da_en,
  gen_da_r,
  gen_da_g,
  gen_da_b,
  test_mode
);

  input clk;
  input rstb;
  input tmg_da_en;
  input [9:0] v_c;
  input [9:0] h_c;
  input test_mode;
  output gen_da_en;
  output [7:0]gen_da_r;
  output [7:0]gen_da_g;
  output [7:0]gen_da_b;

  reg gen_da_en;
  reg [7:0]gen_da_r;
  reg [7:0]gen_da_g;
  reg [7:0]gen_da_b;
  reg [7:0] bv_a_c;
  reg [7:0] bh_a_c;  
  reg [7:0] bv_b_c;
  reg [7:0] bh_b_c;   
  reg [7:0] bv_c_c;
  reg [7:0] bh_c_c;
   
   parameter  size_1 = 125;
   parameter  r_box_v = 50;
   parameter  r_box_h = 150;
   parameter  r_box2_v = 200;
   parameter  r_box2_h = 300;
   parameter  g_box_v = 100;
   parameter  g_box_h = 200;
   parameter  b_box_v = 150;
   parameter  b_box_h = 250;
   
   parameter  size_2 = 20;
   parameter  m_box_v = 150;
   parameter  m_box_h = 300;
   parameter  route_size = 8'd240;
   
   
   
//move_box

always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  begin  
    bv_a_c <= 8'd0;
    bh_a_c <= 8'd0;
  end
else
  if ((tmg_da_en==1'b1)&&(h_c == 10'd799)&&(v_c == 10'd599))
    if (bv_a_c==8'd0)
      if (bh_a_c== route_size)
        begin
          bh_a_c <= route_size;
          bv_a_c <= 8'd1;
        end
      else
        bh_a_c <= bh_a_c +8'd1;
    else
      if (bh_a_c==route_size)
        if(bv_a_c==route_size)
           begin
             bv_a_c <= route_size;
             bh_a_c <= route_size -8'd1;
           end
        else
          bv_a_c <= bv_a_c +8'd1;
      else
        if(bv_a_c==route_size)
          if (bh_a_c==8'd0)
            begin
              bh_a_c <= 8'd0;
              bv_a_c <=  route_size -8'd1;
            end
          else
            bh_a_c <= bh_a_c -8'd1;
        else                          
          if (bh_a_c==8'd0)
            if(bv_a_c==8'd0)
              begin
                bv_a_c <= 8'd0;
                bh_a_c <= 8'd1;
              end
            else
               bv_a_c <= bv_a_c -8'd1;
  else
    begin
      bv_a_c <= bv_a_c;
      bh_a_c <= bh_a_c;
    end       

always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  begin  
    bv_b_c <= 8'd0;
    bh_b_c <= 8'd0;
  end
else
  if ((tmg_da_en==1'b1)&&(h_c == 10'd799)&&(v_c == 10'd599))
    if(bv_b_c==8'd0)
      if (bh_b_c==route_size)
        begin
          bh_b_c <= route_size;
          bv_b_c <= 8'd2;
        end
      else
        bh_b_c <= bh_b_c +8'd2;
    else
      if (bh_b_c==route_size)
        if(bv_b_c>=route_size)
           begin
             bv_b_c <= route_size;
             bh_b_c <= route_size - 8'd2;
           end
        else
          bv_b_c <= bv_b_c +8'd2;
      else
        if(bv_b_c==route_size)
          if (bh_b_c==8'd0)
            begin
              bh_b_c <= 8'd0;
              bv_b_c <=  route_size - 8'd2;
            end
          else
            bh_b_c <= bh_b_c -8'd2;
        else                          
          if (bh_b_c==8'd0)
            if(bv_b_c==8'd0)
              begin
                bv_b_c <= 8'd0;
                bh_b_c <= 8'd2;
              end
            else
               bv_b_c <= bv_b_c -8'd2;
  else
    begin
      bv_b_c <= bv_b_c;
      bh_b_c <= bh_b_c;
    end // else: !if(bv_b_c<=8'd0)

always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  begin  
    bv_c_c <= 8'd0;
    bh_c_c <= 8'd0;
  end
else
  if ((tmg_da_en==1'b1)&&(h_c == 10'd799)&&(v_c == 10'd599))
    if(bv_c_c==8'd0)
      if (bh_c_c==route_size)
        begin
          bh_c_c <= route_size;
          bv_c_c <= 8'd4;
        end
      else
        bh_c_c <= bh_c_c +8'd4;
    else
      if (bh_c_c==route_size)
        if(bv_c_c>=route_size)
           begin
             bv_c_c <= route_size;
             bh_c_c <= route_size - 8'd4;
           end
        else
          bv_c_c <= bv_c_c +8'd4;
      else
        if(bv_c_c==route_size)
          if (bh_c_c==8'd0)
            begin
              bh_c_c <= 8'd0;
              bv_c_c <=  route_size - 8'd4;
            end
          else
            bh_c_c <= bh_c_c -8'd4;
        else                          
          if (bh_c_c==8'd0)
            if(bv_c_c==8'd0)
              begin
                bv_c_c <= 8'd0;
                bh_c_c <= 8'd4;
              end
            else
               bv_c_c <= bv_c_c -8'd4;
  else
    begin
      bv_c_c <= bv_c_c;
      bh_c_c <= bh_c_c;
    end // else: !if(bv_c_c<=8'd0)
   

//rgb data gen   
always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  begin
    gen_da_r <= 8'd0;
    gen_da_g <= 8'd0;
    gen_da_b <= 8'd0;
    gen_da_en <= 1'b0;
    //gen_sync <= 1'b0;
  end
else
  //if (p_en==1'b1)
  if (test_mode==1'b1)
    begin
      //gen_da_en <= tmg_da_en ;
      gen_da_en <= 1'b0 ;
      //gen_sync <= tmg_sync ;
      gen_da_r <= 8'd0;
      gen_da_g <= 8'd0;
      gen_da_b <= 8'd0;
      //red_box
      if   (((v_c>=r_box_v)&&(v_c<=(r_box_v+size_1 ))&&(h_c>=r_box_h)&&(h_c<=(r_box_h+size_1)))||
            ((v_c>=r_box2_v)&&(v_c<=(r_box2_v+size_1))&&(h_c>=r_box2_h)&&(h_c<=(r_box2_h+size_1))))
        begin
          gen_da_en <= 1'b1;       
          gen_da_r <= 8'd255;
        end
      //green_box
      if   ((v_c>=g_box_v)&&(v_c<=(g_box_v+size_1 ))&&(h_c>=g_box_h)&&(h_c<=(g_box_h+size_1)))      
        begin
          gen_da_en <= 1'b1;       
          gen_da_g <= 8'd255;
        end
      //blue_box
      if   ((v_c>=b_box_v)&&(v_c<=(b_box_v+size_1 ))&&(h_c>=b_box_h)&&(h_c<=(b_box_h+size_1)))   
        begin
          gen_da_en <= 1'b1;       
          gen_da_b <= 8'd255;
        end
      //gray bar
      if ((v_c>=60)&&(v_c<=570)&&(h_c>=60)&&(h_c<=100))
        begin
          gen_da_en <= 1'b1;
          gen_da_r <= v_c[9:1]-8'd30;
          gen_da_g <= v_c[9:1]-8'd30;
          gen_da_b <= v_c[9:1]-8'd30;
        end
      //white bar
      if ((v_c>=540)&&(v_c<=570))
        if (((h_c>=200)&&(h_c<=205))||
           ((h_c>=250)&&(h_c<=254))||
           ((h_c>=300)&&(h_c<=303))||
           ((h_c>=350)&&(h_c<=352))||
           ((h_c>=400)&&(h_c<=401)))
        begin
          gen_da_en <= 1'b1;
          gen_da_r<=8'd255;
          gen_da_g<=8'd255;
          gen_da_b<=8'd255;
        end
      //move_bx
      if ((v_c>=bv_a_c+m_box_v)&&(v_c<=(bv_a_c+m_box_v+size_2))&&
          (h_c>=bh_a_c+m_box_h)&&(h_c<=(bh_a_c+m_box_h+size_2)))
        begin
          gen_da_en <= 1'b1;
          gen_da_r<=8'd255;
          gen_da_g<=8'd160;
          gen_da_b<=8'd160;
        end
      if ((v_c>=bv_b_c+m_box_v)&&(v_c<=(bv_b_c+m_box_v+size_2))&&
          (h_c>=bh_b_c+m_box_h)&&(h_c<=(bh_b_c+m_box_h+size_2)))
        begin
          gen_da_en <= 1'b1;
          gen_da_r<=8'd160;
          gen_da_g<=8'd255;
          gen_da_b<=8'd160;
        end
      if ((v_c>=bv_c_c+m_box_v)&&(v_c<=(bv_c_c+m_box_v+size_2))&&
          (h_c>=bh_c_c+m_box_h)&&(h_c<=(bh_c_c+m_box_h+size_2)))
        begin
          gen_da_en <= 1'b1;
          gen_da_r<=8'd160;
          gen_da_g<=8'd160;
          gen_da_b<=8'd255;
        end
    end
  else
    begin
      gen_da_r <= 8'h00;
      gen_da_g <= 8'h00;
      gen_da_b <= 8'h00;
      if ((v_c>=10)&&(v_c<=20)&&(h_c>=10)&&(h_c<=20))
        begin
          gen_da_en <= 1'b1;       
          gen_da_r <= 8'hff;
        end
      if ((v_c>=10)&&(v_c<=20)&&(h_c>=30)&&(h_c<=40))
        begin
          gen_da_en <= 1'b1;       
          gen_da_g <= 8'hff;
        end
      if ((v_c>=10)&&(v_c<=20)&&(h_c>=50)&&(h_c<=60))
        begin
          gen_da_en <= 1'b1;       
          gen_da_b <= 8'hff;
        end
    end

   


   
endmodule








   /*
   //assign radr_v = ((v_c>=0)&&(v_c<=127))?v_c:7'h0;
   assign radr_v = ((v_c>=vram_v)&&(v_c<=(vram_v+size_3)))?v_c[7:1]:7'h0;
   //assign radr_h = ((h_c>=671)&&(h_c<=798))?(h_c-671):7'h0;
   assign h_c_hosei = h_c-vram_h;
   assign radr_h = ((h_c>=vram_h)&&(h_c<=(vram_h+size_3)))?h_c_hosei[7:1]:7'h0;
   
   //assign wea = 1'b0;
   //assign addra=14'h0;

   assign addrb ={radr_v,radr_h};
   //assign doutb = 8'h00;
   
   

  vram varm (
        .clka(clk),
        .wea(wea), // Bus [0 : 0] 
        .addra(addra), // Bus [13 : 0] 
        .dina(dina), // Bus [7 : 0] 
        .clkb(clk),
        .addrb(addrb), // Bus [13 : 0] 
        .doutb(doutb)); // Bus [7 : 0] 
  


always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  begin
     loop <= 16'h0000;
     wea <= 1'b0; 
     addra <= 14'h0;
     dina <= 12'h000;
  end
else
  if (loop==16'hff)
    begin
      loop <= 16'h0000;
      //wea <= 1'b1;       
      wea <= 1'b0;       
      if (addra == 14'h3fff)
        begin
          addra <= 14'h0;
          if ( dina == 8'hff)
            dina <= 12'h00;
          else
            dina <= dina + 12'h1;
        end
      else
        begin
          addra <= addra + 14'h1;
          dina <= dina ;
        end
    end
  else
    begin
      loop <= loop + 16'h1;
      wea <= 1'b0; 
      addra <= addra;
      dina <= dina; 
    end // else: !if(loop==16'hff)

*/


