`timescale 1ps / 1ps
module gazou_gen_b (
  clk,
  rstb,
  tmg_da_en,
  v_c,
  h_c,
  gen_da_en,
  gen_da_r,
  gen_da_g,
  gen_da_b
);

  input clk;
  input rstb;
  input tmg_da_en;
  input [9:0] v_c;
  input [9:0] h_c;
  output gen_da_en;
  output [7:0]gen_da_r;
  output [7:0]gen_da_g;
  output [7:0]gen_da_b;

  reg gen_da_en;
  reg [7:0]gen_da_r;
  reg [7:0]gen_da_g;
  reg [7:0]gen_da_b;
   
  
  // varam signal
   wire [6:0] radr_v;
   wire [6:0] radr_h;
   
   reg     wea;
   reg [13:0] addra;
   reg [11:0] dina;
   wire [13:0] addrb;
   wire [11:0] doutb;
   reg [15:0] loop; 
   wire [9:0] h_c_hosei;

   parameter  size_3 = 255;
   parameter  vram_v = 0;
   parameter  vram_h = 512;
   
always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  begin
    gen_da_r <= 8'd0;
    gen_da_g <= 8'd0;
    gen_da_b <= 8'd0;
    gen_da_en <= 1'b0;  end
else
    begin
      gen_da_en <= 1'b0 ;
      gen_da_r <= 8'd0;
      gen_da_g <= 8'd0;
      gen_da_b <= 8'd0;
      // vram 
      if ((v_c>=vram_v)&&(v_c<=(vram_v+size_3))&&
          (h_c>=vram_h)&&(h_c<=(vram_h+size_3)))
        begin
          gen_da_en <= 1'b1;
          gen_da_r<={doutb[11:8],4'd0};
          gen_da_g<={doutb[7:4],4'd0};
          gen_da_b<={doutb[3:0],4'd0};
        end // if ((v_c>=vram_v)&&(v_c<=(vram_v+size_3))&&...

    end

   assign radr_v = ((v_c>=vram_v)&&(v_c<=(vram_v+size_3)))?v_c[7:1]:7'h0;
   assign h_c_hosei = h_c-vram_h;
   assign radr_h = ((h_c>=vram_h)&&(h_c<=(vram_h+size_3)))?h_c_hosei[7:1]:7'h0;

   assign addrb ={radr_v,radr_h};
   
   

  vram varm (
        .clka(clk),
        .wea(wea), // Bus [0 : 0] 
        .addra(addra), // Bus [13 : 0] 
        .dina(dina), // Bus [7 : 0] 
        .clkb(clk),
        .addrb(addrb), // Bus [13 : 0] 
        .doutb(doutb)); // Bus [7 : 0] 


always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  begin
     loop <= 16'h0000;
     wea <= 1'b0; 
     addra <= 14'h0;
     dina <= 12'h000;
  end
else
  if (loop==16'hff)
    begin
      loop <= 16'h0000;
      //wea <= 1'b1;       
      wea <= 1'b0;       
      if (addra == 14'h3fff)
        begin
          addra <= 14'h0;
          if ( dina == 8'hff)
            dina <= 12'h00;
          else
            dina <= dina + 12'h1;
        end
      else
        begin
          addra <= addra + 14'h1;
          dina <= dina ;
        end
    end
  else
    begin
      loop <= loop + 16'h1;
      wea <= 1'b0; 
      addra <= addra;
      dina <= dina; 
    end // else: !if(loop==16'hff)



   
endmodule








