`timescale 1ps / 1ps
module led_ctrl (
  clk,
  rstb,
  row,
  col,
  led_row_0,
  led_row_1,
  led_row_2,
  led_row_3,
  led_row_4,
  led_row_5,
  led_row_6,
  led_row_7
);

  input clk;
  input rstb;
  output [7:0] row;
  output [7:0] col;
  input [7:0] led_row_0;
  input [7:0] led_row_1;
  input [7:0] led_row_2;
  input [7:0] led_row_3;
  input [7:0] led_row_4;
  input [7:0] led_row_5;
  input [7:0] led_row_6;
  input [7:0] led_row_7;
   
  reg [15:0] row_tim_cnt;   
  reg [2:0] row_cnt;
  reg [11:0] dis_cnt;
  /* 
  reg [7:0] led_row_0;
  reg [7:0] led_row_1;
  reg [7:0] led_row_2;
  reg [7:0] led_row_3;
  reg [7:0] led_row_4;
  reg [7:0] led_row_5;
  reg [7:0] led_row_6;
  reg [7:0] led_row_7;
  */
   
always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  begin  
    row_tim_cnt = 16'd0;
    row_cnt = 3'd0;
    dis_cnt = 12'd0;
  end
else
  if (row_tim_cnt ==16'd39999)
  //if (row_tim_cnt ==12'd39)
    begin
      dis_cnt = dis_cnt + 12'd1;
      row_tim_cnt = 16'd0;
      if (row_cnt ==3'd7)
         row_cnt = 3'd0;
      else 
         row_cnt = row_cnt + 3'd1;
    end
  else
    begin
      dis_cnt = dis_cnt ;
      row_tim_cnt = row_tim_cnt + 16'd1;
      row_cnt = row_cnt ;
    end
/*
always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  begin
     //row_0 <= 8'b11111111;
     //row_1 <= 8'b11111111;
     //row_2 <= 8'b11111111;
     //led_row_3 <= 8'b11111111;
     //led_row_4 <= 8'b11111111;
     //led_row_5 <= 8'b11111111;
     //led_row_6 <= 8'b11111111;
     //led_row_7 <= 8'b11111111;
     //   led_row_0 <= 8'b11001100;
     //   led_row_1 <= 8'b10011001;
     //   led_row_2 <= 8'b00110011;
     //   led_row_3 <= 8'b01100110;
     //   led_row_4 <= 8'b11001100;
     //   led_row_5 <= 8'b10011001;
     //   led_row_6 <= 8'b00110011;
     //   led_row_7 <= 8'b01100110;
     led_row_0 <= 8'b10000000;
     led_row_1 <= 8'b01000000;
     led_row_2 <= 8'b00100000;
     led_row_3 <= 8'b00010000;
     led_row_4 <= 8'b00010000;
     led_row_5 <= 8'b00100000;
     led_row_6 <= 8'b01000000;
     led_row_7 <= 8'b10000000;
  end
else
  if ((led_row_tim_cnt ==16'd39999)&&(dis_cnt[5:0]==6'h1f))
    begin
       led_row_0 <= {led_row_0[0],led_row_0[7:1]};
       led_row_1 <= {led_row_1[0],led_row_1[7:1]};
       led_row_2 <= {led_row_2[0],led_row_2[7:1]};
       led_row_3 <= {led_row_3[0],led_row_3[7:1]};
       led_row_4 <= {led_row_4[0],led_row_4[7:1]};
       led_row_5 <= {led_row_5[0],led_row_5[7:1]};
       led_row_6 <= {led_row_6[0],led_row_6[7:1]};
       led_row_7 <= {led_row_7[0],led_row_7[7:1]};
    end // if (dis_cnt[7:0]==8'hff)
  else
    begin
       led_row_0 <= led_row_0;
       led_row_1 <= led_row_1;
       led_row_2 <= led_row_2;
       led_row_3 <= led_row_3;
       led_row_4 <= led_row_4;
       led_row_5 <= led_row_5;
       led_row_6 <= led_row_6;
       led_row_7 <= led_row_7;       
    end
*/
   
assign row = (row_cnt==3'd0)?8'b11111110:
             (row_cnt==3'd1)?8'b11111101:
             (row_cnt==3'd2)?8'b11111011:
             (row_cnt==3'd3)?8'b11110111:
             (row_cnt==3'd4)?8'b11101111:
             (row_cnt==3'd5)?8'b11011111:
             (row_cnt==3'd6)?8'b10111111:
             (row_cnt==3'd7)?8'b01111111:8'b00000000;

assign col = (row_cnt==3'd0)?led_row_0:
             (row_cnt==3'd1)?led_row_1:
             (row_cnt==3'd2)?led_row_2:
             (row_cnt==3'd3)?led_row_3:
             (row_cnt==3'd4)?led_row_4:
             (row_cnt==3'd5)?led_row_5:
             (row_cnt==3'd6)?led_row_6:
             (row_cnt==3'd7)?led_row_7:8'b00000000;
   
   
endmodule








