`timescale 1ps / 1ps
module vga_crt (
  clk,
  rstb,
  //in_sync,
  out_da_en,
  out_da_r,
  out_da_g,
  out_da_b,
  out_vsync_n,
  out_hsync_n,
  hanten,
  color,
  kaityou,
  test_mode,
  led_0,
  led_1,
  led_2,
  led_3,
  led_4,
  row,
  col
  );

  input clk;
  input rstb;
  //input in_sync;
  output out_da_en;
  output [3:0]out_da_r;
  output [3:0]out_da_g;
  output [3:0]out_da_b;
  output out_vsync_n;
  output out_hsync_n;
  input  hanten;
  input  color ;
  input kaityou;
  input test_mode;
  output led_0;
  output led_1;
  output led_2;
  output led_3;
  output led_4;
  output [7:0] row;
  output [7:0] col;
  //
  wire in_a_da_en;
  wire [7:0]in_a_da_r;
  wire [7:0]in_a_da_g;
  wire [7:0]in_a_da_b;
  // 
  wire in_b_da_en; 
  wire [7:0]in_b_da_r;
  wire [7:0]in_b_da_g;
  wire [7:0]in_b_da_b;
  //
  wire in_c_da_en;
  wire [7:0]in_c_da_r;
  wire [7:0]in_c_da_g;
  wire [7:0]in_c_da_b;
  //
  wire in_d_da_en; 
  wire [7:0]in_d_da_r;
  wire [7:0]in_d_da_g;
  wire [7:0]in_d_da_b;
  //wire sync;
  wire tmg_sync;
  wire tmg_da_en;
  wire [9:0] v_c;
  wire [9:0] h_c;
   
  wire [7:0]out_da_r_tmp;
  wire [7:0]out_da_g_tmp;
  wire [7:0]out_da_b_tmp;
  
  wire [7:0] led_row_0;
  wire [7:0] led_row_1;
  wire [7:0] led_row_2;
  wire [7:0] led_row_3;
  wire [7:0] led_row_4;
  wire [7:0] led_row_5;
  wire [7:0] led_row_6;
  wire [7:0] led_row_7;
 

  assign out_da_r = out_da_r_tmp[7:4];
  assign out_da_g = out_da_g_tmp[7:4];
  assign out_da_b = out_da_b_tmp[7:4];
   
  assign led_1 = hanten;
  assign led_2 = color;
  assign led_3 = kaityou;
  assign led_4 = test_mode;

/*  
gazou_tmg tmg (
  .clk(        clk),        
  .rstb(       rstb),      
  .p_en(       p_en),   
  .p_clk(       p_clk),
  .tmg_sync(   tim_sync),
  .tmg_da_en(  tmg_da_en),
  .out_vsync_n(out_vsync_n),   
  .out_hsync_n(out_hsync_n),
  .led_0(led_0)   
);
*/
   
gazou_gen_a gen_a (
  .clk(    clk),        
  .rstb(     rstb),      
  //.p_en(     p_en),    
  //.tmg_sync( tmg_sync),  
  .tmg_da_en(tmg_da_en),
  .v_c(v_c),
  .h_c(h_c),             
  .gen_da_en(in_a_da_en),
  .gen_da_r( in_a_da_r), 
  .gen_da_g( in_a_da_g), 
  .gen_da_b( in_a_da_b) ,
  //.gen_sync( gen_sync),
  .test_mode( test_mode) 
  /*
  .led_row_0( led_row_0),
  .led_row_1( led_row_1),
  .led_row_2( led_row_2),
  .led_row_3( led_row_3),
  .led_row_4( led_row_4),
  .led_row_5( led_row_5),
  .led_row_6( led_row_6),
  .led_row_7( led_row_7)*/
);

  
gazou_gen_b gen_b (
  .clk(    clk),        
  .rstb(     rstb),   
  .tmg_da_en(tmg_da_en),
  .v_c(v_c),
  .h_c(h_c),             
  .gen_da_en(in_b_da_en),
  .gen_da_r( in_b_da_r), 
  .gen_da_g( in_b_da_g), 
  .gen_da_b( in_b_da_b)
);
   
gazou_gen_c gen_c (
  .clk(    clk),        
  .rstb(     rstb),   
  .tmg_da_en(tmg_da_en),
  .v_c(v_c),
  .h_c(h_c),             
  .gen_da_en(in_c_da_en),
  .gen_da_r( in_c_da_r), 
  .gen_da_g( in_c_da_g), 
  .gen_da_b( in_c_da_b),
  .led_row_0( led_row_0),
  .led_row_1( led_row_1),
  .led_row_2( led_row_2),
  .led_row_3( led_row_3),
  .led_row_4( led_row_4),
  .led_row_5( led_row_5),
  .led_row_6( led_row_6),
  .led_row_7( led_row_7)
);
   
gazou_gen_d gen_d (
  .clk(    clk),        
  .rstb(     rstb),   
  .tmg_da_en(tmg_da_en),
  .v_c(v_c),
  .h_c(h_c),             
  .gen_da_en(in_d_da_en),
  .gen_da_r( in_d_da_r), 
  .gen_da_g( in_d_da_g), 
  .gen_da_b( in_d_da_b)
);

/*   
gazou_syori syori (
  .clk(      clk),        
  .rstb(       rstb),      
  .p_en(p_en),      
  .gen_da_en( gen_da_en),   
  .gen_da_r(  gen_da_r), 
  .gen_da_g(  gen_da_g), 
  .gen_da_b(  gen_da_b), 
  .gen_sync(  gen_sync), 
  .out_da_en( out_da_en), 
  .out_da_r(  out_da_r_tmp), 
  .out_da_g(  out_da_g_tmp), 
  .out_da_b(  out_da_b_tmp),   
  .hanten(hanten),
  .color(color),
  .kaityou(kaityou)
);
*/
   
vga_out vga_out (
  .clk(         clk),           
  .rstb(        rstb),  
  //.tmg_sync( tmg_sync),       
  .tmg_da_en(   tmg_da_en),     
  .out_hsync_n( out_hsync_n),   
  .out_vsync_n( out_vsync_n),   
  .v_c(         v_c),           
  .h_c(         h_c),           
  .led_0(       led_0), 
  .in_a_da_en(  in_a_da_en),      
  .in_a_da_r(   in_a_da_r),       
  .in_a_da_g(   in_a_da_g),       
  .in_a_da_b(   in_a_da_b),      
  .in_b_da_en(  in_b_da_en),      
  .in_b_da_r(   in_b_da_r),       
  .in_b_da_g(   in_b_da_g),       
  .in_b_da_b(   in_b_da_b),      
  .in_c_da_en(  in_c_da_en),      
  .in_c_da_r(   in_c_da_r),       
  .in_c_da_g(   in_c_da_g),       
  .in_c_da_b(   in_c_da_b),      
  .in_d_da_en(  in_d_da_en),      
  .in_d_da_r(   in_d_da_r),       
  .in_d_da_g(   in_d_da_g),       
  .in_d_da_b(   in_d_da_b),       
  .out_da_r(    out_da_r_tmp),      
  .out_da_g(    out_da_g_tmp),      
  .out_da_b(    out_da_b_tmp),      
  .out_da_en(   out_da_en),     
  .hanten(      hanten),        
  .color(       color), 
  .kaityou(     kaityou)            
);

   
led_ctrl led_ctrl (
  .clk(      clk),        
  .rstb(     rstb),
  .row(      row),
  .col(      col),
  .led_row_0( led_row_0),
  .led_row_1( led_row_1),
  .led_row_2( led_row_2),
  .led_row_3( led_row_3),
  .led_row_4( led_row_4),
  .led_row_5( led_row_5),
  .led_row_6( led_row_6),
  .led_row_7( led_row_7)
                   );
   
                   
endmodule



