`timescale 1ps / 1ps
module vga_out (
  clk,
  rstb,
  tmg_da_en,
  out_hsync_n,
  out_vsync_n,
  v_c,
  h_c,
  led_0,
  in_a_da_en,
  in_a_da_r,
  in_a_da_g,
  in_a_da_b,
  in_b_da_en,
  in_b_da_r,
  in_b_da_g,
  in_b_da_b,
  in_c_da_en,
  in_c_da_r,
  in_c_da_g,
  in_c_da_b,
  in_d_da_en,
  in_d_da_r,
  in_d_da_g,
  in_d_da_b,
  out_da_r,
  out_da_g,
  out_da_b,
  out_da_en,
  hanten,
  color,
  kaityou);

  input clk;
  input rstb;
  
  output tmg_da_en;
  output out_vsync_n;
  output out_hsync_n;
  output [9:0] v_c;
  output [9:0] h_c;
  //output p_en;
  //output p_clk;
  output led_0;
  //
  input in_a_da_en;
  input [7:0]in_a_da_r;
  input [7:0]in_a_da_g;
  input [7:0]in_a_da_b;
  //
  input in_b_da_en;
  input [7:0]in_b_da_r;
  input [7:0]in_b_da_g;
  input [7:0]in_b_da_b;
  //
  input in_c_da_en;
  input [7:0]in_c_da_r;
  input [7:0]in_c_da_g;
  input [7:0]in_c_da_b;
  //
  input in_d_da_en;
  input [7:0]in_d_da_r;
  input [7:0]in_d_da_g;
  input [7:0]in_d_da_b;
  //
  output [7:0]out_da_r;
  output [7:0]out_da_g;
  output [7:0]out_da_b;
  output  out_da_en;
  input  hanten;
  input  color ;
  input  kaityou;

  reg tmg_da_en;
  reg disp_da_en;
  reg [9:0] vsync_cnt;
  reg [10:0] hsync_cnt;
  reg vsync;
  reg hsync;
  //reg p_clk ;
  reg tmg_sync;
  reg [4:0]vsync_shift;
  reg [4:0]hsync_shift;
  reg led_0 ;
  reg [25:0]led_cnt ;


   
  reg [7:0]out_da_r;
  reg [7:0]out_da_g;
  reg [7:0]out_da_b;
  reg  out_da_en;
  reg [9:0] v_c;
  reg [9:0] h_c;
  reg [9:0] h_c_1;
  reg [9:0] h_c_2;
  reg [9:0] h_c_3;
  reg [7:0] da_r0;
  reg [7:0] da_r1;
  reg [7:0] da_r2;
  reg [7:0] da_r3;
  reg [7:0] da_r4;
  reg [7:0] da_g0;
  reg [7:0] da_g1;
  reg [7:0] da_g2;
  reg [7:0] da_g3;
  reg [7:0] da_g4;
  reg [7:0] da_b0;
  reg [7:0] da_b1;
  reg [7:0] da_b2;
  reg [7:0] da_b3;
  reg [7:0] da_b4;
  reg [19:0] da_tmp2;

 
  wire in_da_en;
  wire [7:0]in_da_r;
  wire [7:0]in_da_g;
  wire [7:0]in_da_b;
   
  wire [7:0] fda_r0;
  wire [7:0] fda_r1;
  wire [7:0] fda_r2;
  wire [7:0] fda_r3;
  wire [7:0] fda_r4;
  wire [7:0] fda_g0;
  wire [7:0] fda_g1;
  wire [7:0] fda_g2;
  wire [7:0] fda_g3;
  wire [7:0] fda_g4;
  wire [7:0] fda_b0;
  wire [7:0] fda_b1;
  wire [7:0] fda_b2;
  wire [7:0] fda_b3;
  wire [7:0] fda_b4;

  wire [10:0]out_da_r_tmp;
  wire [10:0]out_da_g_tmp;
  wire [10:0]out_da_b_tmp;

  parameter hsync_max = 11'd1055;
  parameter vsync_max = 10'd627;
  parameter h_c_max = 10'd799;
  parameter v_c_max = 10'd599;
  parameter hsync_on_h = 11'd0;
  parameter hsync_off_h = 11'd130;
  parameter vsync_on_v = 10'd0;
  parameter vsync_on_h = 11'd0;
  parameter vsync_off_v = 10'd4;
  parameter vsync_off_h = 11'd0;
  parameter da_on_v = 10'd28;
  parameter da_on_h = 11'd220;
  parameter da_off_v = 10'd627;
  parameter da_off_h = 11'd1020;
   
   
always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  begin  
    vsync_cnt <= 10'd0;
    hsync_cnt <= 11'd0;
  end
else
  if (hsync_cnt == hsync_max)
    begin
       hsync_cnt <= 11'd0;
        //if (vsync_cnt == 10'd665)
        //if (vsync_cnt == 10'd627)
        if (vsync_cnt == vsync_max)
          vsync_cnt <= 10'd0;
        else
          vsync_cnt <= vsync_cnt + 10'd1;
    end
  else
    begin
      hsync_cnt <= hsync_cnt +11'd1;
      vsync_cnt <= vsync_cnt ;
    end

always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  begin 
     tmg_sync  <= 1'b1; 
    vsync <= 1'b0;
    hsync <= 1'b0;
    tmg_da_en <= 1'b0;
    disp_da_en <= 1'b0;
  end
else
    begin
      if ((vsync_cnt==10'd0)&&(hsync_cnt==11'd0))
        tmg_sync  <= 1'b1;
      else 
        tmg_sync  <= 1'b0;
      /* 
      if ((vsync_cnt==10'd6)&&(hsync_cnt==11'd199))
        vsync <= 1'b1;
      else
        if ((vsync_cnt==10'd0)&&(hsync_cnt==11'd199))
          vsync <= 1'b0;
        else
          vsync <= vsync;
      if((vsync_cnt==10'd0)&&(hsync_cnt==11'd0))
        hsync <= 1'b0;
      else
        if (hsync_cnt==11'd79)
          hsync <= 1'b1;
        else
          if  (hsync_cnt==11'd1039)
            hsync <= 1'b0;
          else
            hsync <= hsync;
      */
      //if ((vsync_cnt==10'd0)&&(hsync_cnt==11'd0))
      if ((vsync_cnt==vsync_on_v)&&(hsync_cnt==vsync_on_h))
        vsync <= 1'b1;
      else
        if ((vsync_cnt==vsync_off_v)&&(hsync_cnt==vsync_off_h))
          vsync <= 1'b0;
        else
          vsync <= vsync;
      //if((vsync_cnt==10'd0)&&(hsync_cnt==11'd0))
      //  hsync <= 1'b1;
      //else
      //if (hsync_cnt==11'd0)
      if (hsync_cnt==hsync_on_h)
        hsync <= 1'b1;
      else
        //if  (hsync_cnt==11'd130)
        if  (hsync_cnt==hsync_off_h)
          hsync <= 1'b0;
        else
          hsync <= hsync;
       
      if((vsync_cnt==10'd0)&&(hsync_cnt==11'd0))        
        tmg_da_en <= 1'b0;
      else
        //if ((vsync_cnt>=10'd29)&&(vsync_cnt <= 10'd628))
        //if ((vsync_cnt>=10'd28)&&(vsync_cnt <= 10'd627))
        if ((vsync_cnt>=da_on_v)&&(vsync_cnt <= da_off_v))
          //if (hsync_cnt==11'd199)
          //if (hsync_cnt==11'd220)
          if (hsync_cnt==da_on_h)
            tmg_da_en <= 1'b1;
          else
            //if  (hsync_cnt==11'd999)
            //if  (hsync_cnt==11'd1020)
            if  (hsync_cnt==da_off_h)
              tmg_da_en <= 1'b0;
            else
              tmg_da_en <= tmg_da_en;
        else
          tmg_da_en <= 1'b0;
       disp_da_en <= tmg_da_en; 
    end
 

always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  begin 
        vsync_shift <= 5'b00000;
        hsync_shift <= 5'b00000;
  end
else
  begin
    vsync_shift <= {vsync_shift[3:0],vsync};
    hsync_shift <= {hsync_shift[3:0],hsync};
  end

assign out_vsync_n = vsync_shift[4];
assign out_hsync_n = hsync_shift[4];

   
always @ (posedge clk or negedge rstb )
if (rstb==1'b0)
  begin 
    led_cnt <= 26'b0;
    led_0 <= 1'b1;
  end
else
  if (led_cnt == 26'd40000000)
    begin
      led_cnt <= 26'b0;
       led_0 <= ~led_0;
    end
  else
    begin
       led_cnt <= led_cnt + 26'd1;
       led_0 <= led_0;
    end


   
always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  begin  
    v_c <= 10'd0;
    h_c <= 10'd0;
  end
else
    if (tmg_sync==1'b1)
          begin 
          v_c <= 10'd0;
          h_c <= 10'd0;
        end
    else
      //if (in_da_en==1'b1)
      if (tmg_da_en==1'b1)
          if (h_c == 10'd799)
                begin
              h_c <= 10'd0;
                  if (v_c == 10'd599)
                v_c <= 10'd0;
                  else
                v_c <= v_c + 10'd1;
                end
          else
                begin
              h_c <= h_c +10'd1;
              v_c <= v_c ;
                end
       else
         begin
           h_c <= h_c ;
           v_c <= v_c ;
         end

   assign in_da_r =(in_a_da_en==1'b1)?in_a_da_r:
                   (in_b_da_en==1'b1)?in_b_da_r:
                   (in_c_da_en==1'b1)?in_c_da_r:in_d_da_r;
   assign in_da_g =(in_a_da_en==1'b1)?in_a_da_g:
                   (in_b_da_en==1'b1)?in_b_da_g:
                   (in_c_da_en==1'b1)?in_c_da_g:in_d_da_g;
   assign in_da_b =(in_a_da_en==1'b1)?in_a_da_b:
                   (in_b_da_en==1'b1)?in_b_da_b:
                   (in_c_da_en==1'b1)?in_c_da_b:in_d_da_b;
   
  

always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  begin 
    da_r0 <= 8'd0;
    da_r1 <= 8'd0;
    da_r2 <= 8'd0;
    da_r3 <= 8'd0;
    da_r4 <= 8'd0;
    da_g0 <= 8'd0;
    da_g1 <= 8'd0;
    da_g2 <= 8'd0;
    da_g3 <= 8'd0;
    da_g4 <= 8'd0;
    da_b0 <= 8'd0;
    da_b1 <= 8'd0;
    da_b2 <= 8'd0;
    da_b3 <= 8'd0;
    da_b4 <= 8'd0;
    h_c_1 <= 10'd0;
    h_c_2 <= 10'd0;
  end
else
   begin
          da_r0 <= in_da_r;
          da_r1 <= da_r0;
          da_r2 <= da_r1;
          da_r3 <= da_r2;
          da_r4 <= da_r3;
          da_g0 <= in_da_g;
          da_g1 <= da_g0;
          da_g2 <= da_g1;
          da_g3 <= da_g2;
          da_g4 <= da_g3;
          da_b0 <= in_da_b;
          da_b1 <= da_b0;
          da_b2 <= da_b1;
          da_b3 <= da_b2;
          da_b4 <= da_b3;
          h_c_1 <= h_c;
          h_c_2 <= h_c_1;
          h_c_3 <= h_c_2;
        end
 
   assign fda_r4 =(h_c_3==10'd0)?da_r2:
                  (h_c_3==10'd1)?da_r3:da_r4;
   
   assign fda_r3 =(h_c_3==10'd0)?da_r2:da_r3;
   assign fda_r2 = da_r2;
   assign fda_r1 =(h_c_3==10'd699)?da_r2:da_r1;
   assign fda_r0 =(h_c_3==10'd698)?da_r1:
                  (h_c_3==10'd699)?da_r2:da_r0;
   
   assign fda_g4 =(h_c_3==10'd0)?da_g2:
                  (h_c_3==10'd1)?da_g3:da_g4;
   assign fda_g3 =(h_c_3==10'd0)?da_g2:da_g3;
   assign fda_g2 = da_g2;
   assign fda_g1 =(h_c_3==10'd699)?da_g2:da_g1;
   assign fda_g0 =(h_c_3==10'd698)?da_g1:
                  (h_c_2==10'd699)?da_g2:da_g0;
   assign fda_b4 =(h_c_3==10'd0)?da_b2:
                  (h_c_2==10'd1)?da_b3:da_b4;
   assign fda_b3 =(h_c_3==10'd0)?da_b2:da_b3;
   assign fda_b2 = da_b2;
   assign fda_b1 =(h_c_3==10'd699)?da_b2:da_b1;
   assign fda_b0 =(h_c_3==10'd698)?da_b1:
                  (h_c_3==10'd699)?da_b2:da_b0;


   
always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  begin
    out_da_r <= 8'd0;
    out_da_g <= 8'd0;
    out_da_b <= 8'd0;
  end
else
  if (disp_da_en==1'b0)
    begin
      out_da_r <= 8'd0;
      out_da_g <= 8'd0;
      out_da_b <= 8'd0;
    end
  else
      if (hanten==1'b0)
      //if (hanten==1'b1)
        begin
          out_da_r  <= 8'd255-in_da_r;
          out_da_g  <= 8'd255-in_da_g;
          out_da_b  <= 8'd255-in_da_b;
        end
      else
        if (color==1'b0)
        //if (color==1'b1)
          begin
             //da_tmp2 =  (0.1*in_da_r + 10'd601*in_da_g + 10'd117*in_da_b);
             da_tmp2 =  (10'd306*in_da_r + 10'd601*in_da_g + 10'd117*in_da_b);
             out_da_r  <= da_tmp2[17:10]; // 1/1024
             out_da_g  <= da_tmp2[17:10];
             out_da_b  <= da_tmp2[17:10];
           end
        else
          if (kaityou==1'b0)
          //if (kaityou==1'b1)
            begin
              //out_da_r  <= (fda_r0+fda_r1+fda_r2+fda_r3+fda_r4)/5;
              //out_da_g  <= (fda_g0+fda_g1+fda_g2+fda_g3+fda_g4)/5;
              //out_da_b  <= (fda_b0+fda_b1+fda_b2+fda_b3+fda_b4)/5;
              out_da_r <= out_da_r_tmp[9:2];
              out_da_g <= out_da_g_tmp[9:2];
              out_da_b <= out_da_b_tmp[9:2];
               
          end
          else
            begin
              out_da_r  <= in_da_r;
              out_da_g  <= in_da_g;
              out_da_b  <= in_da_b;
            end

   assign out_da_r_tmp = (fda_r0+fda_r1+fda_r2+fda_r3);
   

   assign out_da_g_tmp = (fda_g0+fda_g1+fda_g2+fda_g3);
   

   assign out_da_b_tmp = (fda_b0+fda_b1+fda_b2+fda_b3);
   

   
always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  begin
          out_da_en <= 1'b0;
  end
else
        begin
          out_da_en <= out_da_en;
        end
   
endmodule






